--- encoder/analyse.c
+++ encoder/analyse.c
@@ -306,14 +306,17 @@
 /* Max = 4 */
 static void predict_16x16_mode_available( unsigned int i_neighbour, int *mode, int *pi_count )
 {
-    if( i_neighbour & MB_TOPLEFT )
+    if( (i_neighbour & (MB_LEFT|MB_TOP)) == (MB_LEFT|MB_TOP) )
     {
         /* top and left avaible */
         *mode++ = I_PRED_16x16_V;
         *mode++ = I_PRED_16x16_H;
         *mode++ = I_PRED_16x16_DC;
-        *mode++ = I_PRED_16x16_P;
-        *pi_count = 4;
+        *pi_count = 3;
+        if( i_neighbour & MB_TOPLEFT ) {
+            *mode++ = I_PRED_16x16_P;
+            *pi_count = 4;
+        }
     }
     else if( i_neighbour & MB_LEFT )
     {
@@ -340,14 +343,17 @@
 /* Max = 4 */
 static void predict_8x8chroma_mode_available( unsigned int i_neighbour, int *mode, int *pi_count )
 {
-    if( i_neighbour & MB_TOPLEFT )
+    if( (i_neighbour & (MB_LEFT|MB_TOP)) == (MB_LEFT|MB_TOP) )
     {
         /* top and left avaible */
         *mode++ = I_PRED_CHROMA_V;
         *mode++ = I_PRED_CHROMA_H;
         *mode++ = I_PRED_CHROMA_DC;
-        *mode++ = I_PRED_CHROMA_P;
-        *pi_count = 4;
+        *pi_count = 3;
+        if( i_neighbour & MB_TOPLEFT ) {
+            *mode++ = I_PRED_CHROMA_P;
+            *pi_count = 4;
+        }
     }
     else if( i_neighbour & MB_LEFT )
     {
